#include <Servo.h>
#include <XBee.h>
 

XBee xbee = XBee();
XBeeResponse response = XBeeResponse(); 
Rx16Response rx16 = Rx16Response();
int pos = 0;
int izquierda = 0;
int adelante = 0;
int atras = 0;
int derecha = 0;
Servo myservo;

/*Valores de configuración*/
int pinledrecepcion = 13;
int pinenable = 12;
int pinacelerar = 11;
int pinmarchaatras = 10;
int pinservo = 9;

 
void setup(){
  xbee.begin(9600);
  pinMode(pinenable,OUTPUT);
  pinMode(pinacelerar,OUTPUT);
  pinMode(pinmarchaatras,OUTPUT);
  digitalWrite(pinenable,HIGH);
  myservo.attach(pinservo);  
  myservo.write(8);
}
void acelerar(){
  digitalWrite(pinacelerar,HIGH);
  delay(2000);
  digitalWrite(pinacelerar,LOW); 
}
void marchaatras(){
  digitalWrite(pinmarchaatras,HIGH);
  delay(1000);
  digitalWrite(pinmarchatras,LOW); 
}
void girarderecha(){
  pos = myservo.read();
  delay(20);
  if(pos == 108){
    myservo.write(126);
    delay(20);
  }else if(pos == 90){
    myservo.write(108);
    delay(20);
  }
}
void girarizquierda(){
  pos = myservo.read();
  delay(20);
  if(pos == 108){
    myservo.write(90);
    delay(20);
  }else if(pos == 126){
    myservo.write(108);
    delay(20);
  }
}
void loop(){ 
    xbee.readPacket();
    derecha = 0;
    adelante = 0;
    atras = 0;
    izquierda = 0;
    if (xbee.getResponse().isAvailable()) {
        if (xbee.getResponse().getApiId() == RX_16_RESPONSE) {
                xbee.getResponse().getRx16Response(rx16);
                derecha = rx16.getData(0);
                adelante = rx16.getData(1);
                atras = rx16.getData(2);
                izquierda = rx16.getData(3);
                digitalWrite(pinledrecepcion,HIGH);
                delay(1000);
                digitalWrite(pinledrecepcion,LOW);
                if(izquierda == 1){
                  girarizquierda(); 
                }else if(adelante == 1){
                  acelerar(); 
                }else if(atras == 1){
                  marchaatras(); 
                }else if(derecha == 1){
                  girarderecha();
                }
        }
      }
}
